package imcacat.imcadr;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

/**
 * I test <code>ImcadrServerResult</code>.
 */
public class ImcadrServerResultTest {
  @Test
  public void testSnapshot01() {
    ImcadrServerResult result =
        new ImcadrServerResult(new Rectangle(5.0, 4.0, LengthUnit.CELL), new Rectangle(3.0, 2.0,
            LengthUnit.CELL));
    result.setProgress(88);
    result.setState(ImcadrServerState.RUNNING);
    result.setMessage("Rastering ZX plane");
    result.setOriginZy(Position2d.mm(1.2, 2.3));
    result.setOriginZx(Position2d.mm(3.4, 4.5));
    result.setCenterZy(Position2d.mm(9.2, 9.8));
    result.setCenterZx(Position2d.mm(0.0, 0.0));
    ImcadrServerResult snapshot = result.snapshot(null);
    assertEquals(result.getProgress(), snapshot.getProgress());
    assertEquals(result.getState(), snapshot.getState());
    assertEquals(result.getMessage(), snapshot.getMessage());
    assertEquals(result.getOriginZy(), snapshot.getOriginZy());
    assertEquals(result.getOriginZx(), snapshot.getOriginZx());
    assertEquals(result.getCenterZy(), snapshot.getCenterZy());
    assertEquals(result.getCenterZx(), snapshot.getCenterZx());
    assertEquals(result.getCenter(), snapshot.getCenter());
    assertEquals(result.getTime(), snapshot.getTime());
  }
}
