package imcacat.imcadr;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import org.junit.Test;

/**
 * I test <code>LengthUnit</code>.
 */
public class LengthUnitTest {
  @Test
  public void testConversionRatio01() {
    assertNull(LengthUnit.conversionRatio(LengthUnit.ARBITRARY, LengthUnit.METER));
    assertNull(LengthUnit.conversionRatio(LengthUnit.METER, LengthUnit.ARBITRARY));
    assertNull(LengthUnit.conversionRatio(LengthUnit.CELL, LengthUnit.METER));
    assertNull(LengthUnit.conversionRatio(LengthUnit.METER, LengthUnit.CELL));
  }

  @Test
  public void testConversionRatio02() {
    assertEquals(1.0, LengthUnit.conversionRatio(LengthUnit.METER, LengthUnit.METER), 1e-6);
    assertEquals(1.0, LengthUnit.conversionRatio(LengthUnit.MILLIMETER, LengthUnit.MILLIMETER),
        1e-6);
    assertEquals(1.0, LengthUnit.conversionRatio(LengthUnit.MICROMETER, LengthUnit.MICROMETER),
        1e-6);
    assertEquals(1.0, LengthUnit.conversionRatio(LengthUnit.NANOMETER, LengthUnit.NANOMETER),
        1e-6);
    assertEquals(1.0, LengthUnit.conversionRatio(LengthUnit.PICOMETER, LengthUnit.PICOMETER),
        1e-6);

    assertEquals(1e3, LengthUnit.conversionRatio(LengthUnit.METER, LengthUnit.MILLIMETER), 1e-6);
    assertEquals(1e6, LengthUnit.conversionRatio(LengthUnit.METER, LengthUnit.MICROMETER), 1e-15);
    assertEquals(1e9, LengthUnit.conversionRatio(LengthUnit.METER, LengthUnit.NANOMETER), 1e-15);
    assertEquals(1e12, LengthUnit.conversionRatio(LengthUnit.METER, LengthUnit.PICOMETER), 1e-15);

    assertEquals(1e-3, LengthUnit.conversionRatio(LengthUnit.MILLIMETER, LengthUnit.METER), 1e-6);
    assertEquals(1e-6, LengthUnit.conversionRatio(LengthUnit.MICROMETER, LengthUnit.METER),
        1e-15);
    assertEquals(1e-9, LengthUnit.conversionRatio(LengthUnit.NANOMETER, LengthUnit.METER), 1e-15);
    assertEquals(1e-12, LengthUnit.conversionRatio(LengthUnit.PICOMETER, LengthUnit.METER),
        1e-15);
  }

  @Test
  public void testConversionRatio03() {
    assertEquals(1e3, LengthUnit.conversionRatio(LengthUnit.MILLIMETER, LengthUnit.MICROMETER),
        1e-6);
    assertEquals(1e3, LengthUnit.conversionRatio(LengthUnit.MICROMETER, LengthUnit.NANOMETER),
        1e-6);
    assertEquals(1e3, LengthUnit.conversionRatio(LengthUnit.NANOMETER, LengthUnit.PICOMETER),
        1e-6);

    assertEquals(1e-3, LengthUnit.conversionRatio(LengthUnit.MICROMETER, LengthUnit.MILLIMETER),
        1e-6);
    assertEquals(1e-3, LengthUnit.conversionRatio(LengthUnit.NANOMETER, LengthUnit.MICROMETER),
        1e-6);
    assertEquals(1e-3, LengthUnit.conversionRatio(LengthUnit.PICOMETER, LengthUnit.NANOMETER),
        1e-6);

    assertEquals(1e9, LengthUnit.conversionRatio(LengthUnit.MILLIMETER, LengthUnit.PICOMETER),
        1e-6);
    assertEquals(1e-9, LengthUnit.conversionRatio(LengthUnit.PICOMETER, LengthUnit.MILLIMETER),
        1e-12);
  }
}
