package imcacat.imcadr;

import java.io.InputStream;
import java.io.OutputStream;

/**
 * I am a Mock object of <tt>ImcadrServer</tt>.
 */
public class MockImcadrServer extends ImcadrServer {
  public static final long SHUTDOWN_TIMEOUT = 1000L;

  public MockImcadrServer(InputStream in, OutputStream out) {
    this(new Imcadr(new MockBeamlineDriver()), in, out);
  }

  public MockImcadrServer(Imcadr model, InputStream in, OutputStream out) {
    super(model, in, out);
  }

  @Override
  protected ImcadrServerSession createSession() {
    return new MockImcadrServerSession(model.getBeamlineDriver());
  }

  public Imcadr getModel() {
    return model;
  }
}
