package imcacat.imcadr;

import java.util.Map;

/**
 * I am a Mock object of <tt>Rasterizer3d</tt>.
 */
public class MockRasterizer3d extends Rasterizer3d {
  private static final long serialVersionUID = 1;

  public MockRasterizer3d(Raster3dSpec spec, boolean firePropertyChangesOnEdtEnabled,
      Map<Position2d, Integer> zyScores, Map<Position2d, Integer> zxScores) {
    this(spec, new MockBeamlineDriver(), firePropertyChangesOnEdtEnabled, zyScores, zxScores);
  }

  public MockRasterizer3d(Raster3dSpec spec, BeamlineDriver driver,
      boolean firePropertyChangesOnEdtEnabled, Map<Position2d, Integer> zyScores,
      Map<Position2d, Integer> zxScores) {
    this(spec, driver, firePropertyChangesOnEdtEnabled, zyScores, zxScores, null);
  }

  public MockRasterizer3d(Raster3dSpec spec, BeamlineDriver driver,
      boolean firePropertyChangesOnEdtEnabled, Map<Position2d, Integer> zyScores,
      Map<Position2d, Integer> zxScores, Position2d scoreLookUpDelta) {
    super(spec, driver, new MockRasterizer2d(spec.getZySpec(), driver,
        firePropertyChangesOnEdtEnabled, zyScores, scoreLookUpDelta), new MockRasterizer2d(
        spec.getZxSpec(), driver, firePropertyChangesOnEdtEnabled, zxScores, scoreLookUpDelta),
        firePropertyChangesOnEdtEnabled);
    doNotWriteResultsFile();
    doNotLogException();
  }
}
