package imcacat.imcadr;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

/**
 * I test <code>Position2d</code>.
 */
public class Position2dTest {
  @Test
  public void testEquals01() {
    Position2d p1 = Position2d.mm(1.0, 2.0);
    Position2d p2 = Position2d.mm(1.0, 2.0);
    assertTrue(p1.equals(p2));
  }

  @Test
  public void testEquals02() {
    Position2d p1 = Position2d.mm(1.0, 2.0);
    Position2d p2 = Position2d.mm(1.0, 3.0);
    assertFalse(p1.equals(p2));
  }

  @Test
  public void testEquals03() {
    Position2d p1 = Position2d.mm(1.0, 2.0);
    Position2d p2 = Position2d.mm(2.0, 2.0);
    assertFalse(p1.equals(p2));
  }

  @Test
  public void testConvertTo01() {
    Position2d pos = Position2d.mm(2.0, 3.5);
    assertEquals(pos, pos.convertTo(LengthUnit.MILLIMETER));
  }

  @Test
  public void testConvertTo02() {
    Position2d posMm = Position2d.mm(2.0, 3.5);
    Position2d posUm = Position2d.um(2000.0, 3500.0);
    assertEquals(posUm, posMm.convertTo(LengthUnit.MICROMETER));
    assertEquals(posMm, posUm.convertTo(LengthUnit.MILLIMETER));
  }
}
