package imcacat.imcadr;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

/**
 * I test <code>Position3d</code>.
 */
public class Position3dTest {
  @Test
  public void testEquals01() {
    Position3d p1 = Position3d.mm(1.0, 2.0, 3.0);
    Position3d p2 = Position3d.mm(1.0, 2.0, 3.0);
    assertTrue(p1.equals(p2));
  }

  @Test
  public void testEquals02() {
    Position3d p1 = Position3d.mm(1.0, 2.0, 3.0);
    Position3d p2 = Position3d.mm(1.0, 2.0, 4.0);
    assertFalse(p1.equals(p2));
  }

  @Test
  public void testEquals03() {
    Position3d p1 = Position3d.mm(1.0, 2.0, 3.0);
    Position3d p2 = Position3d.mm(1.0, 3.0, 3.0);
    assertFalse(p1.equals(p2));
  }

  @Test
  public void testEquals04() {
    Position3d p1 = Position3d.mm(1.0, 2.0, 3.0);
    Position3d p2 = Position3d.mm(2.0, 2.0, 3.0);
    assertFalse(p1.equals(p2));
  }

  @Test
  public void testConvertTo01() {
    Position3d pos = Position3d.mm(2.0, 3.5, 4.1);
    assertEquals(pos, pos.convertTo(LengthUnit.MILLIMETER));
  }

  @Test
  public void testConvertTo02() {
    Position3d posMm = Position3d.mm(2.0, 3.5, 4.1);
    Position3d posUm = Position3d.um(2000.0, 3500.0, 4100.0);
    assertEquals(posUm, posMm.convertTo(LengthUnit.MICROMETER));
    assertEquals(posMm, posUm.convertTo(LengthUnit.MILLIMETER));
  }
}
