package imcacat.imcadr;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

import java.io.File;

import org.junit.Test;

/**
 * I test <code>Raster2dColumnFlyScanIterator</code>.
 */
public class Raster2dColumnFlyScanIteratorTest {
  @Test
  public void testNext() {
    Raster2d raster = createRaster(4, 3);
    Raster2dColumnFlyScanIterator iter = newIterator(raster);
    Raster2dFlyScan scan = iter.next();
    assertEquals(new Raster2dIndex(0, 0), scan.startCell().getIndex());
    assertEquals(new Raster2dIndex(0, 2), scan.endCell().getIndex());
    scan = iter.next();
    assertEquals(new Raster2dIndex(1, 2), scan.startCell().getIndex());
    assertEquals(new Raster2dIndex(1, 0), scan.endCell().getIndex());
    scan = iter.next();
    assertEquals(new Raster2dIndex(2, 0), scan.startCell().getIndex());
    assertEquals(new Raster2dIndex(2, 2), scan.endCell().getIndex());
    scan = iter.next();
    assertEquals(new Raster2dIndex(3, 2), scan.startCell().getIndex());
    assertEquals(new Raster2dIndex(3, 0), scan.endCell().getIndex());
    assertFalse(iter.hasNext());
  }

  private static Raster2d createRaster(int numCols, int numRows) {
    return new Raster2d(new Raster2dSpec(Raster2dPlane.ZY, numCols, numRows, 0.3, 0.2,
        LengthUnit.MILLIMETER, 500, 2, true, true, 25, new File("/nonexistent"), null), ".cbf",
        false);
  }

  private static Raster2dColumnFlyScanIterator newIterator(Raster2d raster) {
    return new Raster2dColumnFlyScanIterator(raster);
  }
}
