package imcacat.imcadr;

/**
 * I provide utility methods for use in testing.
 */
public class TestUtils {
  private TestUtils() {
    throw new AssertionError();
  }

  /**
   * Creates a new {@code Raster2dMask} from the specified array.
   *
   * @param maskArray [row][column] mask array where nonzero is {@code true}
   *
   * @return a new {@code Raster2dMask}
   */
  public static Raster2dMask newMask(int[][] maskArray) {
    Raster2dMask result = new Raster2dMask();
    for (int r = 0; r < maskArray.length; r++) {
      for (int c = 0; c < maskArray[0].length; c++) {
        if (maskArray[r][c] != 0) result.set(c, r, true);
      }
    }
    return result;
  }
}
