package imcacat.imcadr.util;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

/**
 * I test <code>DurationUtils</code>.
 */
public class DurationUtilsTest {
  @Test
  public void testCreateTimeString_basic() {
    assertEquals("15s", DurationUtils.createTimeString(15000));
    assertEquals("1m0s", DurationUtils.createTimeString(60000));
    assertEquals("1m2s", DurationUtils.createTimeString(62000));
    assertEquals("2m0s", DurationUtils.createTimeString(120000));
    assertEquals("1h0m0s", DurationUtils.createTimeString(3600000));
    assertEquals("1d0h0m0s", DurationUtils.createTimeString(86400000));
  }

  @Test
  public void testCreateTimeString_roundMillisecondsUpToNearestSecond() {
    assertEquals("0s", DurationUtils.createTimeString(0));
    assertEquals("1s", DurationUtils.createTimeString(1));
    assertEquals("1s", DurationUtils.createTimeString(501));
    assertEquals("1s", DurationUtils.createTimeString(999));
    assertEquals("1s", DurationUtils.createTimeString(1000));
    assertEquals("2s", DurationUtils.createTimeString(1001));
  }
}
