package imcacat.imcadr.util;

import static org.junit.Assert.assertEquals;
import imcacat.imcadr.Rectangle;

import org.junit.Test;

/**
 * I test <code>GeometryUtils</code>.
 */
public class GeometryUtilsTest {
  @Test
  public void testScale01() {
    Rectangle expected = new Rectangle(1.0, 1.0);
    Rectangle actual = GeometryUtils.scale(1.0, 1.0, 1.0, 1.0);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }

  @Test
  public void testScale02() {
    Rectangle expected = new Rectangle(2.0, 2.0);
    Rectangle actual = GeometryUtils.scale(1.0, 1.0, 1.0, 2.0);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }

  @Test
  public void testScale03() {
    Rectangle expected = new Rectangle(2.0, 2.0);
    Rectangle actual = GeometryUtils.scale(1.0, 1.0, 2.0, 1.0);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }

  @Test
  public void testScale04() {
    Rectangle expected = new Rectangle(1.0, 2.0);
    Rectangle actual = GeometryUtils.scale(1.0, 2.0, 1.0, 1.0);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }

  @Test
  public void testScale05() {
    Rectangle expected = new Rectangle(4.0, 1.3333);
    Rectangle actual = GeometryUtils.scale(3.0, 1.0, 4.0, 1.0);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }

  @Test
  public void testScale06() {
    Rectangle expected = new Rectangle(2.625, 1.5);
    Rectangle actual = GeometryUtils.scale(70.0, 40.0, 2.5, 1.5);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }

  @Test
  public void testScale07() {
    Rectangle expected = new Rectangle(2.5, 4.375);
    Rectangle actual = GeometryUtils.scale(40.0, 70.0, 2.5, 1.5);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }

  @Test
  public void testScale08() {
    Rectangle expected = new Rectangle(2.5, 2.5);
    Rectangle actual = GeometryUtils.scale(50.0, 50.0, 2.5, 1.5);
    assertEquals(expected.getWidth(), actual.getWidth(), 0.001);
    assertEquals(expected.getHeight(), actual.getHeight(), 0.001);
  }
}
