package imcacat.imcadr.util;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

/**
 * I test <code>NetworkUtils</code>.
 */
public class NetworkUtilsTest {
  @Test
  public void testIsLocalhost() {
    assertFalse(NetworkUtils.isLocalhost(null));
    assertFalse(NetworkUtils.isLocalhost(""));
    assertFalse(NetworkUtils.isLocalhost(" "));

    assertFalse(NetworkUtils.isLocalhost("192.168.0.1"));

    assertTrue(NetworkUtils.isLocalhost("localhost"));
    assertTrue(NetworkUtils.isLocalhost("127.0.0.1"));
    assertTrue(NetworkUtils.isLocalhost("::1"));

    assertTrue(NetworkUtils.isLocalhost("127.0.0.2"));
    assertTrue(NetworkUtils.isLocalhost("127.1.0.1"));
    assertTrue(NetworkUtils.isLocalhost("127.0.1.1"));

    /* Invalid IPv4 address. */
    assertFalse(NetworkUtils.isLocalhost("127.0.0.1001"));
    /* Invalid IPv4 address. */
    assertFalse(NetworkUtils.isLocalhost("127.0.0.256"));
  }
}
