package imcacat.imcadr;

import imcacat.imcadr.util.Pair;

import javax.swing.JProgressBar;

import com.jgoodies.binding.adapter.BasicComponentFactory;
import com.jgoodies.binding.value.ValueModel;

/**
 * I am a Java Swing component Factory. I am an instance of the Factory
 * pattern.
 */
public class ComponentFactory extends BasicComponentFactory {
  public static Pair<JProgressBar, ProgressBarMediator> createProgressBar(
      ValueModel progressModel) {
    return createProgressBar(progressModel, null);
  }

  public static Pair<JProgressBar, ProgressBarMediator> createProgressBar(
      ValueModel progressModel, ValueModel progressStringModel) {
    JProgressBar progressBar = new JProgressBar();
    progressBar.setStringPainted(true);
    ProgressBarMediator mediator =
        new ProgressBarMediator(progressBar, progressModel, progressStringModel);
    return new Pair<JProgressBar, ProgressBarMediator>(progressBar, mediator);
  }
}
