package imcacat.imcadr;

import imcacat.epicsca4j.model.EpicsEnum;

/**
 * I model an experiment state in J. Lewis Muir's imcais software.
 */
public enum ExperimentState implements EpicsEnum {
  IDLE,
  MOUNT,
  UNMOUNT,
  ANNEAL,
  AUTO_CENTER,
  MANUAL_CENTER,
  COLLECT_DATA;

  public short asEpicsShort() {
    return (short)this.ordinal();
  }

  public ExperimentState fromEpicsShort(short epicsEnumValue) {
    for (ExperimentState each : ExperimentState.values())
      if (each.ordinal() == epicsEnumValue) return each;
    throw new IllegalArgumentException("Unexpected value: " + epicsEnumValue);
  }
}
