package imcacat.imcadr;

import java.io.File;

/**
 * I am thrown when deleting a file fails.
 */
public class FileDeleteException extends Exception {
  private static final long serialVersionUID = 1;

  protected File file;

  public FileDeleteException(File file) {
    this(file, createMessage(file));
  }

  public FileDeleteException(File file, String message) {
    super(message);
    this.file = file;
  }

  public FileDeleteException(File file, Throwable cause) {
    this(file, createMessage(file), cause);
  }

  public FileDeleteException(File file, String message, Throwable cause) {
    super(message, cause);
    this.file = file;
  }

  private static String createMessage(File file) {
    return "Failed to delete \"" + file.getPath() + "\"";
  }
}
