package imcacat.imcadr;

import java.io.File;

/**
 * I am thrown when renaming a file fails.
 */
public class FileRenameException extends Exception {
  private static final long serialVersionUID = 1;

  protected File from;
  protected File to;

  public FileRenameException(File from, File to) {
    this(from, to, createMessage(from, to));
  }

  public FileRenameException(File from, File to, String message) {
    super(message);
    this.from = from;
    this.to = to;
  }

  public FileRenameException(File from, File to, Throwable cause) {
    this(from, to, createMessage(from, to), cause);
  }

  public FileRenameException(File from, File to, String message, Throwable cause) {
    super(message, cause);
    this.from = from;
    this.to = to;
  }

  private static String createMessage(File from, File to) {
    return "Failed to rename \"" + from.getPath() + "\" to \"" + to.getPath() + "\"";
  }
}
