package imcacat.imcadr;

/**
 * I am the result produced by an {@link ImageAnalysis}.
 */
public class ImageAnalysisResult {
  private Integer score;
  private Integer spotTotal;
  private Integer inResTotal;
  private Integer goodBraggTotal;
  private Integer iceRingTotal;
  private Double estimatedRes1;
  private Double estimatedRes2;
  private Integer totalIntSignal;
  private Double mosaicity;
  private SpaceGroup spaceGroup;
  private UnitCell unitCell;
  private String errorMessage;
  private Throwable errorCause;

  public ImageAnalysisResult() {
    super();
  }

  public Integer getScore() {
    return score;
  }

  public void setScore(Integer score) {
    this.score = score;
  }

  public Integer getSpotTotal() {
    return spotTotal;
  }

  public void setSpotTotal(Integer spotTotal) {
    this.spotTotal = spotTotal;
  }

  public Integer getInResolutionTotal() {
    return inResTotal;
  }

  public void setInResolutionTotal(Integer inResTotal) {
    this.inResTotal = inResTotal;
  }

  public Integer getGoodBraggTotal() {
    return goodBraggTotal;
  }

  public void setGoodBraggTotal(Integer goodBraggTotal) {
    this.goodBraggTotal = goodBraggTotal;
  }

  public Integer getIceRingTotal() {
    return iceRingTotal;
  }

  public void setIceRingTotal(Integer iceRingTotal) {
    this.iceRingTotal = iceRingTotal;
  }

  public Double getEstimatedResolution1() {
    return estimatedRes1;
  }

  public void setEstimatedResolution1(Double estimatedRes1) {
    this.estimatedRes1 = estimatedRes1;
  }

  public Double getEstimatedResolution2() {
    return estimatedRes2;
  }

  public void setEstimatedResolution2(Double estimatedRes2) {
    this.estimatedRes2 = estimatedRes2;
  }

  public Integer getTotalIntegratedSignal() {
    return totalIntSignal;
  }

  public void setTotalIntegratedSignal(Integer totalIntSignal) {
    this.totalIntSignal = totalIntSignal;
  }

  public Double getMosaicity() {
    return mosaicity;
  }

  public void setMosaicity(Double mosaicity) {
    this.mosaicity = mosaicity;
  }

  public SpaceGroup getSpaceGroup() {
    return spaceGroup;
  }

  public void setSpaceGroup(SpaceGroup spaceGroup) {
    this.spaceGroup = spaceGroup;
  }

  public UnitCell getUnitCell() {
    return unitCell;
  }

  public void setUnitCell(UnitCell unitCell) {
    this.unitCell = unitCell;
  }

  public String getErrorMessage() {
    return errorMessage;
  }

  public void setErrorMessage(String errorMessage) {
    this.errorMessage = errorMessage;
  }

  public Throwable getErrorCause() {
    return errorCause;
  }

  public void setErrorCause(Throwable errorCause) {
    this.errorCause = errorCause;
  }

  public void setError(String errorMessage, Throwable errorCause) {
    setErrorMessage(errorMessage);
    setErrorCause(errorCause);
  }

  public boolean wasSuccessful() {
    return errorMessage == null && errorCause == null;
  }
}
