package imcacat.imcadr;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * I run a {@code Rasterizer3d} for {@code ImcadrServer}.
 */
public class ImcadrServerRasterizer3dThread extends ImcadrServerRasterizerThread {
  public ImcadrServerRasterizer3dThread(Rasterizer3d rasterizer, ImcadrServerResult result) {
    super(rasterizer, result);
    setDaemon(false);
    registerResultInterest(rasterizer);
  }

  protected void registerResultInterest(Rasterizer3d r) {
    registerResultProgressInterest(r);
    registerResultStateInterest(r);
    registerResultOriginInterest(r);
    registerResultScoresInterest(r);
    registerResultSpotTotalsInterest(r);
    registerResultInResolutionTotalsInterest(r);
    registerResultGoodBraggTotalsInterest(r);
    registerResultIceRingTotalsInterest(r);
    registerResultEstimatedResolutions1Interest(r);
    registerResultEstimatedResolutions2Interest(r);
    registerResultTotalIntegratedSignalsInterest(r);
    registerResultMosaicitiesInterest(r);
    registerResultSpaceGroupsInterest(r);
    registerResultUnitCellsInterest(r);
    registerResultCenterInterest(r);
    registerResultTimeInterest(r);
  }

  protected void registerResultOriginInterest(Rasterizer3d r) {
    registerResultOriginInterest(r.getZyRasterizer());
    registerResultOriginInterest(r.getZxRasterizer());
  }

  protected void registerResultScoresInterest(Rasterizer3d r) {
    registerResultScoresInterest(r.getZyRasterizer());
    registerResultScoresInterest(r.getZxRasterizer());
  }

  protected void registerResultSpotTotalsInterest(Rasterizer3d r) {
    registerResultSpotTotalsInterest(r.getZyRasterizer());
    registerResultSpotTotalsInterest(r.getZxRasterizer());
  }

  protected void registerResultInResolutionTotalsInterest(Rasterizer3d r) {
    registerResultInResolutionTotalsInterest(r.getZyRasterizer());
    registerResultInResolutionTotalsInterest(r.getZxRasterizer());
  }

  protected void registerResultGoodBraggTotalsInterest(Rasterizer3d r) {
    registerResultGoodBraggTotalsInterest(r.getZyRasterizer());
    registerResultGoodBraggTotalsInterest(r.getZxRasterizer());
  }

  protected void registerResultIceRingTotalsInterest(Rasterizer3d r) {
    registerResultIceRingTotalsInterest(r.getZyRasterizer());
    registerResultIceRingTotalsInterest(r.getZxRasterizer());
  }

  protected void registerResultEstimatedResolutions1Interest(Rasterizer3d r) {
    registerResultEstimatedResolutions1Interest(r.getZyRasterizer());
    registerResultEstimatedResolutions1Interest(r.getZxRasterizer());
  }

  protected void registerResultEstimatedResolutions2Interest(Rasterizer3d r) {
    registerResultEstimatedResolutions2Interest(r.getZyRasterizer());
    registerResultEstimatedResolutions2Interest(r.getZxRasterizer());
  }

  protected void registerResultTotalIntegratedSignalsInterest(Rasterizer3d r) {
    registerResultTotalIntegratedSignalsInterest(r.getZyRasterizer());
    registerResultTotalIntegratedSignalsInterest(r.getZxRasterizer());
  }

  protected void registerResultMosaicitiesInterest(Rasterizer3d r) {
    registerResultMosaicitiesInterest(r.getZyRasterizer());
    registerResultMosaicitiesInterest(r.getZxRasterizer());
  }

  protected void registerResultSpaceGroupsInterest(Rasterizer3d r) {
    registerResultSpaceGroupsInterest(r.getZyRasterizer());
    registerResultSpaceGroupsInterest(r.getZxRasterizer());
  }

  protected void registerResultUnitCellsInterest(Rasterizer3d r) {
    registerResultUnitCellsInterest(r.getZyRasterizer());
    registerResultUnitCellsInterest(r.getZxRasterizer());
  }

  protected void registerResultCenterInterest(final Rasterizer3d r) {
    registerResultCenterInterest(r.getZyRasterizer());
    registerResultCenterInterest(r.getZxRasterizer());
    r.addPropertyChangeListener(Rasterizer3d.PROPNAME_BEST_POSITION,
        new PropertyChangeListener() {
          public void propertyChange(PropertyChangeEvent event) {
            updateResultCenter((Position3d)event.getNewValue(), r);
          }
        });
  }

  protected void updateResultCenter(Position3d newCenter, Rasterizer3d r) {
    result.setCenter(newCenter);
  }
}
