package imcacat.imcadr;

import com.jgoodies.binding.beans.Model;

/**
 * I am the settings for this application.
 */
public class ImcadrSettings extends Model {
  private static final long serialVersionUID = 1;

  public static final String PROPNAME_RASTER_CELL_WIDTH = "rasterCellWidth";
  public static final String PROPNAME_RASTER_CELL_HEIGHT = "rasterCellHeight";
  public static final String PROPNAME_ZY_RASTER_WIDTH = "zyRasterWidth";
  public static final String PROPNAME_ZY_RASTER_HEIGHT = "zyRasterHeight";
  public static final String PROPNAME_ZX_RASTER_WIDTH = "zxRasterWidth";
  public static final String PROPNAME_ZX_RASTER_HEIGHT = "zxRasterHeight";
  public static final String PROPNAME_EXPOSURE_TIME = "exposureTime";
  public static final String PROPNAME_MAX_NUM_CONCURRENT_ANALYZERS = "maxNumConcurrentAnalyzers";
  public static final String PROPNAME_CHASING_ENABLED = "chasingEnabled";
  public static final String PROPNAME_WEAK_DIFFRACTER = "weakDiffracter";
  public static final String PROPNAME_HIGH_RES_CUTOFF = "highResolutionCutoff";

  protected int rasterCellWidth = 70;
  protected int rasterCellHeight = 40;
  protected int zyRasterWidth = 3;
  protected int zyRasterHeight = 5;
  protected int zxRasterWidth = 3;
  protected int zxRasterHeight = 5;
  protected long exposureTime = 250;
  protected int maxNumConcurrentAnalyzers = Runtime.getRuntime().availableProcessors();
  protected boolean chasingEnabled = true;
  protected boolean weakDiffracter = false;
  protected double highResolutionCutoff = Resources.getInstance()
      .getWeakDiffracterHighResolutionCutoff();

  public int getRasterCellWidth() {
    return rasterCellWidth;
  }

  public void setRasterCellWidth(int rasterCellWidth) {
    int oldValue = this.rasterCellWidth;
    this.rasterCellWidth = rasterCellWidth;
    if (oldValue != rasterCellWidth) {
      firePropertyChange(ImcadrSettings.PROPNAME_RASTER_CELL_WIDTH, oldValue, rasterCellWidth);
    }
  }

  public int getRasterCellHeight() {
    return rasterCellHeight;
  }

  public void setRasterCellHeight(int rasterCellHeight) {
    int oldValue = this.rasterCellHeight;
    this.rasterCellHeight = rasterCellHeight;
    if (oldValue != rasterCellHeight) {
      firePropertyChange(ImcadrSettings.PROPNAME_RASTER_CELL_HEIGHT, oldValue, rasterCellHeight);
    }
  }

  public int getZyRasterWidth() {
    return zyRasterWidth;
  }

  public void setZyRasterWidth(int zyRasterWidth) {
    int oldValue = this.zyRasterWidth;
    this.zyRasterWidth = zyRasterWidth;
    if (oldValue != zyRasterWidth) {
      firePropertyChange(ImcadrSettings.PROPNAME_ZY_RASTER_WIDTH, oldValue, zyRasterWidth);
    }
  }

  public int getZyRasterHeight() {
    return zyRasterHeight;
  }

  public void setZyRasterHeight(int zyRasterHeight) {
    int oldValue = this.zyRasterHeight;
    this.zyRasterHeight = zyRasterHeight;
    if (oldValue != zyRasterHeight) {
      firePropertyChange(ImcadrSettings.PROPNAME_ZY_RASTER_HEIGHT, oldValue, zyRasterHeight);
    }
  }

  public int getZxRasterWidth() {
    return zxRasterWidth;
  }

  public void setZxRasterWidth(int zxRasterWidth) {
    int oldValue = this.zxRasterWidth;
    this.zxRasterWidth = zxRasterWidth;
    if (oldValue != zxRasterWidth) {
      firePropertyChange(ImcadrSettings.PROPNAME_ZX_RASTER_WIDTH, oldValue, zxRasterWidth);
    }
  }

  public int getZxRasterHeight() {
    return zxRasterHeight;
  }

  public void setZxRasterHeight(int zxRasterHeight) {
    int oldValue = this.zxRasterHeight;
    this.zxRasterHeight = zxRasterHeight;
    if (oldValue != zxRasterHeight) {
      firePropertyChange(ImcadrSettings.PROPNAME_ZX_RASTER_HEIGHT, oldValue, zxRasterHeight);
    }
  }

  public long getExposureTime() {
    return exposureTime;
  }

  public void setExposureTime(long exposureTime) {
    long oldValue = this.exposureTime;
    this.exposureTime = exposureTime;
    if (oldValue != exposureTime) {
      firePropertyChange(ImcadrSettings.PROPNAME_EXPOSURE_TIME, oldValue, exposureTime);
    }
  }

  public int getMaxNumConcurrentAnalyzers() {
    return maxNumConcurrentAnalyzers;
  }

  public void setMaxNumConcurrentAnalyzers(int maxNumConcurrentAnalyzers) {
    int oldValue = this.maxNumConcurrentAnalyzers;
    this.maxNumConcurrentAnalyzers = maxNumConcurrentAnalyzers;
    if (oldValue == maxNumConcurrentAnalyzers) return;
    firePropertyChange(ImcadrSettings.PROPNAME_MAX_NUM_CONCURRENT_ANALYZERS, oldValue,
        maxNumConcurrentAnalyzers);
  }

  public boolean isChasingEnabled() {
    return chasingEnabled;
  }

  public void setChasingEnabled(boolean chasingEnabled) {
    boolean oldValue = this.chasingEnabled;
    this.chasingEnabled = chasingEnabled;
    if (oldValue == chasingEnabled) return;
    firePropertyChange(ImcadrSettings.PROPNAME_CHASING_ENABLED, oldValue, chasingEnabled);
  }

  public boolean isWeakDiffracter() {
    return weakDiffracter;
  }

  public void setWeakDiffracter(boolean weakDiffracter) {
    boolean oldValue = this.weakDiffracter;
    this.weakDiffracter = weakDiffracter;
    if (oldValue == weakDiffracter) return;
    firePropertyChange(ImcadrSettings.PROPNAME_WEAK_DIFFRACTER, oldValue, weakDiffracter);
  }

  public double getHighResolutionCutoff() {
    return highResolutionCutoff;
  }

  public void setHighResolutionCutoff(double highResolutionCutoff) {
    double oldValue = this.highResolutionCutoff;
    this.highResolutionCutoff = highResolutionCutoff;
    if (oldValue != highResolutionCutoff) {
      firePropertyChange(ImcadrSettings.PROPNAME_HIGH_RES_CUTOFF, oldValue, highResolutionCutoff);
    }
  }
}
