package imcacat.imcadr;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import com.jgoodies.binding.PresentationModel;

/**
 * I am the presentation model for {@link ImcadrSettingsDialog}.
 */
public class ImcadrSettingsPresentationModel extends PresentationModel<ImcadrSettings> {
  private static final long serialVersionUID = 1;

  public ImcadrSettingsPresentationModel(ImcadrSettings bean) {
    super(bean);

    updateHighResolutionCutoffEnablement(bean.isWeakDiffracter());
    getModel(ImcadrSettings.PROPNAME_WEAK_DIFFRACTER).addValueChangeListener(
        new PropertyChangeListener() {
          public void propertyChange(PropertyChangeEvent event) {
            updateHighResolutionCutoffEnablement((Boolean)event.getNewValue());
          }
        });
  }

  private void updateHighResolutionCutoffEnablement(Boolean enabled) {
    getComponentModel(ImcadrSettings.PROPNAME_HIGH_RES_CUTOFF).setEnabled(enabled);
  }
}
