package imcacat.imcadr;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.ParsePosition;

/**
 * I am just like a <code>DecimalFormat</code> except I always return an
 * instance of <code>Integer</code> (i.e.&nbsp;I never return a
 * <code>Long</code>, <code>Double</code>, etc.).
 *
 * @see DecimalFormat
 */
public class IntegerDecimalFormat extends DecimalFormat {
  private static final long serialVersionUID = 1;

  public IntegerDecimalFormat() {
    super();
  }

  public IntegerDecimalFormat(String pattern) {
    super(pattern);
  }

  public IntegerDecimalFormat(String pattern, DecimalFormatSymbols symbols) {
    super(pattern, symbols);
  }

  public Number parse(String text, ParsePosition pos) {
    Number aNumber = super.parse(text, pos);
    if (aNumber != null && !(aNumber instanceof Integer)) aNumber =
        new Integer(aNumber.intValue());
    return aNumber;
  }
}
