package imcacat.imcadr;

/**
 * I am thrown when a process exits with an abnormal exit status
 * (e.g.&nbsp;non-zero).
 */
public class NonzeroProcessExitValueException extends Exception {
  private static final long serialVersionUID = 1;

  protected int exitStatus = 0;

  public NonzeroProcessExitValueException() {
    super();
  }

  public NonzeroProcessExitValueException(String message) {
    super(message);
  }

  public NonzeroProcessExitValueException(int exitStatus, String processOutput) {
    super("Process exited with exit status " + exitStatus + " and with the following output: " +
        processOutput);
    this.exitStatus = exitStatus;
  }

  public int getExitStatus() {
    return exitStatus;
  }
}
