package imcacat.imcadr;

import java.awt.Frame;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;

/**
 * I open a modal {@link ImcadrSettingsDialog} when I am performed.
 */
public class OpenImcadrSettingsDialogAction extends AbstractAction {
  private static final long serialVersionUID = 1;

  protected ImcadrSettings model;
  protected String dialogTitle;
  protected Frame ownerFrame;

  public OpenImcadrSettingsDialogAction(Frame ownerFrame, String name, String dialogTitle,
      ImcadrSettings model) {
    super();
    this.ownerFrame = ownerFrame;
    this.dialogTitle = dialogTitle;
    this.model = model;
    putValue(Action.NAME, name);
  }

  public void actionPerformed(ActionEvent e) {
    ImcadrSettingsPresentationModel presentationModel =
        new ImcadrSettingsPresentationModel(model);
    ImcadrSettingsDialog dialog =
        new ImcadrSettingsDialog(ownerFrame, dialogTitle, true, presentationModel);
    dialog.pack();
    dialog.setLocationRelativeTo(ownerFrame);
    dialog.setResizable(false);
    dialog.setVisible(true);
    presentationModel.release();
  }
}
