package imcacat.imcadr;

/**
 * I represent a value range.
 */
public class Range<T> {
  private final T low;
  private final T high;

  public Range(T low, T high) {
    super();
    this.low = low;
    this.high = high;
  }

  public T low() {
    return low;
  }

  public T high() {
    return high;
  }

  @Override
  public boolean equals(Object obj) {
    if (obj == null) return false;
    if (!(obj instanceof Range<?>)) return false;
    Range<?> objRange = (Range<?>)obj;
    Object objRangeLow = objRange.low();
    if (low == null) {
      if (objRangeLow != null) return false;
    } else {
      if (objRangeLow == null) return false;
      if (!(low.equals(objRangeLow))) return false;
    }
    Object objRangeHigh = objRange.high();
    if (high == null) {
      if (objRangeHigh != null) return false;
    } else {
      if (objRangeHigh == null) return false;
      if (!(high.equals(objRangeHigh))) return false;
    }
    return true;
  }

  @Override
  public int hashCode() {
    return ((low == null) ? 0 : low.hashCode()) ^ ((high == null) ? 0 : high.hashCode());
  }

  @Override
  public String toString() {
    return "Range(" + low + ", " + high + ")";
  }
}
