package imcacat.imcadr;

/**
 * I represent an index into a {@link Raster2d}. I am an instance of the
 * Parameter Object pattern.
 */
public class Raster2dIndex {
  protected int column = 0;
  protected int row = 0;

  public Raster2dIndex() {
    super();
  }

  public Raster2dIndex(int column, int row) {
    super();
    this.column = column;
    this.row = row;
  }

  public int getColumn() {
    return column;
  }

  public int getRow() {
    return row;
  }

  @Override
  public boolean equals(Object anObject) {
    if (anObject == null) return false;
    if (!(anObject instanceof Raster2dIndex)) return false;
    Raster2dIndex aRaster2dIndex = (Raster2dIndex)anObject;
    if (column != aRaster2dIndex.column) return false;
    return row == aRaster2dIndex.row;
  }

  @Override
  public int hashCode() {
    return column ^ row;
  }

  @Override
  public String toString() {
    return Raster2dIndex.class.getName() + "(col=" + column + ",row=" + row + ")";
  }
}
