package imcacat.imcadr;

import java.util.Iterator;

/**
 * A {@link Raster2d} iterator providing access to the index of the next
 * element.
 */
public interface Raster2dIterator extends Iterator<RasterCell> {
  /**
   * Returns the column index of the next element in the iteration but does not
   * advance the iteration to the next element.
   *
   * @return the column index of the next element in the iteration
   *
   * @throws NoSuchElementException if the iteration has no more elements
   */
  int nextColumn();

  /**
   * Returns the row index of the next element in the iteration but does not
   * advance the iteration to the next element.
   *
   * @return the row index of the next element in the iteration
   *
   * @throws NoSuchElementException if the iteration has no more elements
   */
  int nextRow();

  /**
   * Returns the index of the next element in the iteration but does not
   * advance the iteration to the next element.
   *
   * @return the index of the next element in the iteration
   *
   * @throws NoSuchElementException if the iteration has no more elements
   */
  Raster2dIndex nextIndex();
}