package imcacat.imcadr;

import java.awt.BorderLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * I display a {@link Rasterizer3d}.
 */
public class Rasterizer3dPanel extends JPanel {
  private static final long serialVersionUID = 1;

  protected Rasterizer3dPresentationModel model;

  public Rasterizer3dPanel(Rasterizer3dPresentationModel model) {
    super(new BorderLayout());
    this.model = model;
    add(build(), BorderLayout.CENTER);
  }

  protected JPanel build() {
    /* @formatter:off */
    FormLayout layout = new FormLayout(
        /* Columns */
        "left:pref, 4dlu, left:pref:grow",
        /* Row: ZY Raster */
        "pref, 2dlu, pref, 2dlu, pref, 2dlu, pref, 8dlu, " +
        /* Row: ZX Raster */
        "pref, 2dlu, pref, 2dlu, pref, 2dlu, pref, 8dlu, " +
        /* Row: Combined Raster */
        "pref, 2dlu, pref, 2dlu, pref");
    layout.setRowGroups(
        new int[][] {
            {1, 9, 17},
            {5, 7, 13, 15, 19, 21}
        });
    /* @formatter:on */
    PanelBuilder builder = new PanelBuilder(layout);
    builder.setBorder(Borders.DLU4_BORDER);
    CellConstraints cc = new CellConstraints();

    builder.addTitle("ZY (\u03A6 at 0\u00B0) Raster", cc.xy(1, 1, "left, bottom"));

    builder.add(new Rasterizer2dPanel(model.getZyRasterizerPresentationModel()),
        cc.xyw(1, 3, 3, "left, center"));

    builder.addLabel("Center (Z, Y):", cc.xy(1, 5));
    JLabel zyCenterStringValueLabel =
        ComponentFactory.createLabel(model.getZyRasterizerPresentationModel().getModel(
            Rasterizer2d.PROPNAME_BEST_POSITION_STRING));
    builder.add(zyCenterStringValueLabel, cc.xy(3, 5));

    builder.addLabel("Time (total, acquire, score):", cc.xy(1, 7));
    JLabel zyTimeStringValueLabel =
        ComponentFactory.createLabel(model.getZyRasterizerPresentationModel().getModel(
            Rasterizer2d.PROPNAME_TIME_STRING));
    builder.add(zyTimeStringValueLabel, cc.xy(3, 7));

    builder.addTitle("ZX (\u03A6 at 90\u00B0) Raster", cc.xy(1, 9, "left, bottom"));

    builder.add(new Rasterizer2dPanel(model.getZxRasterizerPresentationModel()),
        cc.xyw(1, 11, 3, "left, center"));

    builder.addLabel("Center (Z, X):", cc.xy(1, 13));
    JLabel zxCenterStringValueLabel =
        ComponentFactory.createLabel(model.getZxRasterizerPresentationModel().getModel(
            Rasterizer2d.PROPNAME_BEST_POSITION_STRING));
    builder.add(zxCenterStringValueLabel, cc.xy(3, 13));

    builder.addLabel("Time (total, acquire, score):", cc.xy(1, 15));
    JLabel zxTimeStringValueLabel =
        ComponentFactory.createLabel(model.getZxRasterizerPresentationModel().getModel(
            Rasterizer2d.PROPNAME_TIME_STRING));
    builder.add(zxTimeStringValueLabel, cc.xy(3, 15));

    builder.addTitle("Solution", cc.xy(1, 17, "left, bottom"));

    builder.addLabel("Center (X, Y, Z):", cc.xy(1, 19));
    JLabel resultCenterStringValueLabel =
        ComponentFactory.createLabel(model.getModel(Rasterizer3d.PROPNAME_BEST_POSITION_STRING));
    builder.add(resultCenterStringValueLabel, cc.xy(3, 19));

    builder.addLabel("Time (total, acquire, score):", cc.xy(1, 21));
    JLabel resultTimeStringValueLabel =
        ComponentFactory.createLabel(model.getModel(Rasterizer3d.PROPNAME_TIME_STRING));
    builder.add(resultTimeStringValueLabel, cc.xy(3, 21));

    return builder.getPanel();
  }
}
