package imcacat.imcadr;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.value.ValueHolder;
import com.jgoodies.binding.value.ValueModel;

/**
 * I am the presentation model for a {@link Rasterizer3d}.
 */
public class Rasterizer3dPresentationModel extends PresentationModel<Rasterizer3d> {
  private static final long serialVersionUID = 1;

  protected Rasterizer2dPresentationModel zyRasterizerPresentationModel;
  protected Rasterizer2dPresentationModel zxRasterizerPresentationModel;

  public Rasterizer3dPresentationModel(Rasterizer3d bean) {
    this(new ValueHolder(bean, true));
  }

  public Rasterizer3dPresentationModel(ValueModel beanChannel) {
    this(beanChannel, new ValueHolder(""));
  }

  public Rasterizer3dPresentationModel(ValueModel beanChannel, ValueModel mouseOverString) {
    super(beanChannel);
    zyRasterizerPresentationModel =
        new Rasterizer2dPresentationModel(getModel(Rasterizer3d.PROPNAME_ZY_RASTERIZER),
            mouseOverString);
    zxRasterizerPresentationModel =
        new Rasterizer2dPresentationModel(getModel(Rasterizer3d.PROPNAME_ZX_RASTERIZER),
            mouseOverString);
  }

  public Rasterizer2dPresentationModel getZyRasterizerPresentationModel() {
    return zyRasterizerPresentationModel;
  }

  public Rasterizer2dPresentationModel getZxRasterizerPresentationModel() {
    return zxRasterizerPresentationModel;
  }
}
