package imcacat.imcadr;

/**
 * Thrown when a {@link Rasterizer} is unsuccessful in rasterizing a raster.
 */
public class UnsuccessfulRasterizeException extends Exception {
  private static final long serialVersionUID = 1L;

  private final Rasterizer rasterizer;

  public UnsuccessfulRasterizeException(Rasterizer rasterizer) {
    this(null, rasterizer);
  }

  public UnsuccessfulRasterizeException(String message, Rasterizer rasterizer) {
    super(message);
    this.rasterizer = rasterizer;
  }

  public Rasterizer getRasterizer() {
    return rasterizer;
  }
}
