package imcacat.imcadr.util;

import java.awt.Color;

/**
 * I provide utilities related to colors.
 */
public class ColorUtils {
  private ColorUtils() {
    throw new AssertionError();
  }

  public static Color getTemperature(Double valueObj, double min, double max) {
    double value = (valueObj == null) ? min : valueObj.doubleValue();
    int redBlueScore = (int)Math.round(MathUtils.scale(value, min, max, 0.0, 510.0));
    int red = Math.min(255, redBlueScore);
    int blue = Math.max(0, 255 - (redBlueScore - red));
    return new Color(red, 0, blue);
  }
}
