package imcacat.imcadr.util;

import java.util.Enumeration;
import java.util.logging.ConsoleHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

/**
 * I provide utilities related to logging.
 */
public class LoggingUtils {
  private LoggingUtils() {
    throw new AssertionError();
  }

  /*
   * The only handler that writes to the console in this application
   * is the ConsoleHandler, so disable console logging by turning off
   * logging of all ConsoleHandler instances.  If the set of handlers
   * were not known, this approach would not be sufficient since a
   * custom handler could write to the console.
   */
  public static void disableConsoleLogging() {
    LogManager m = LogManager.getLogManager();
    for (Enumeration<String> e = m.getLoggerNames(); e.hasMoreElements();) {
      Logger l = m.getLogger(e.nextElement());
      if (l == null) continue;
      for (Handler h : l.getHandlers()) {
        if (h instanceof ConsoleHandler) h.setLevel(Level.OFF);
      }
    }
  }
}
