package imcacat.imcadr.util;

/**
 * I provide additional {@link Math} methods.
 */
public class MathUtils {
  private MathUtils() {
    throw new AssertionError();
  }

  public static int scale(int value, int low, int high, int newLow, int newHigh) {
    return (int)scale((double)value, (double)low, (double)high, (double)newLow, (double)newHigh);
  }

  public static double scale(double value, double low, double high, double newLow, double newHigh) {
    if (low == high) return newLow;
    if (value <= low) return newLow;
    if (value >= high) return newHigh;
    double range = high - low;
    double valuePercentageOfRange = (value - low) / range;
    double newRange = newHigh - newLow;
    return newLow + (valuePercentageOfRange * newRange);
  }

  public static boolean even(int value) {
    return (value % 2) == 0;
  }

  public static boolean odd(int value) {
    return !even(value);
  }

  public static double round(double value, int numDecimalPlaces) {
    double scale = Math.pow(10.0, numDecimalPlaces);
    return Math.rint(value * scale) / scale;
  }
}
